/*
* BrushlessMach
*
* Mach controls a brushless ESC
* Update by druckgott
*
*/

#include <Servo.h> 
 
Servo myservo;
 
int pos = 0;
  
//Sub Pin 7 => GND
//Sub Pin 2 => +5V
#define inPin  2     // pwm input from Mach3 to this Pin (Sub Pin 11)
#define ledPin 13    // LED connected to digital pin 13
#define servoPin 9    // Connection for Brushless Motor to Signal pin (orange/yellow)
#define startPin 10  // Connection for starting/stop Signal of the Spindle (Sub Pin 10)

#define PWM_PERIOD  100000 // the number of microseconds for one PWM cycle
#define PWM_IDLE_STATE  LOW   // set this to HIGH or LOW depending on how the mach3 outputs PWM

#define DEBUG 1 // get Serial out on Terminal


void setup()
{
  if(DEBUG){
	Serial.begin(9600);      // open the serial port at 9600 bps:
  }
  myservo.attach(servoPin); //Initial the Servo
  pinMode(startPin, INPUT); //Initial Start/Stop Pin
}

void loop()
{
  //get PWM signal from Mach3
  long  pwmIn = pulseIn( inPin,  PWM_IDLE_STATE );
  //check if the spindle should run
  if(digitalRead(startPin) == HIGH){
	pwmIn=0;
  }
  //Map PWM Signal from Mach3 to Servo Signal
  //angle: the value to write to the servo, from 0 to 180 
  long escOut2 = map(pwmIn, 0, PWM_PERIOD, 0, 180);
  //Move Servo/Motor
  //angle: the value to write to the servo, from 0 to 180 
  myservo.write(escOut2);

  if(DEBUG){
  	long escOut = map(pwmIn, 0, PWM_PERIOD, 0, 255);
  	analogWrite(ledPin, escOut);
  	// add the following for serial output
  	Serial.print(pwmIn);
  	Serial.print(", ");
  	Serial.println(escOut, DEC);
	}

  delay(1000);
}
